<?php
#(c)7/2015, Milan Stepanek, LysaFree.net 

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
   die("<br><strong>This script is only meant to run at the command line.</strong>");
}

# deactivate http headers
$no_http_headers = true;

#params
$snmp_hostname  = $argv[1];         #hostname
$snmp_community = $argv[2];         #community string
$snmp_timeout   = 500000;	        #snmp timeout useconds
$snmp_retries   = 2;		        #snmp retries

#get cpu load
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);
$cpu = @snmpwalk($snmp_hostname, $snmp_community, ".1.3.6.1.2.1.25.3.3.1.2", $snmp_timeout, $snmp_retries);

#min/max/average
$cpu_cnt = count($cpu);
$cpu_min = min($cpu);
$cpu_max = max($cpu);
$cpu_avg = round(array_sum($cpu)/count($cpu),2);

#Sum
$sum1=$sum2=$sum3=$sum4=0;
for($i=0; $i<count($cpu); $i++) {
    if($i%4 == 0)
        $sum1 += $cpu[$i];      #cpu core 0,4,8...
    elseif(($i-1)%4 == 0)
        $sum2 += $cpu[$i];      #cpu core 1,5,9...
    elseif(($i-2)%4 == 0)
        $sum3 += $cpu[$i];      #cpu core 2,6,10...
    else
        $sum4 += $cpu[$i];      #cpu core 3,7,11...
}

print "cpu_cnt:$cpu_cnt cpu_min:$cpu_min cpu_max:$cpu_max cpu_avg:$cpu_avg sum1:$sum1 sum2:$sum2 sum3:$sum3 sum4:$sum4";
?>
